#include "fileinfo.h"

class fileInfo
{
    
    public:
        int fileProperties(fileName string){
            struct stat fileInfo;
            
           if (stat(argv[1], &fileInfo) != 0) {  // Use stat( ) to get the info
              std::cerr << "Error: " << strerror(errno) << '\n';
              return(EXIT_FAILURE);
           }
        
           std::cout << "Type:         : ";
           if ((fileInfo.st_mode & S_IFMT) == S_IFDIR) { // From sys/types.h
              std::cout << "Directory\n";
           } else {
              std::cout << "File\n";
           }
        
           std::cout << "Size          : " << fileInfo.st_size << '\n'; // Size in bytes
           std::cout << "Device        : " << (char)(fileInfo.st_dev + 'A') << '\n';  // Device number
           std::cout << "Created       : " <<  std::ctime(&fileInfo.st_ctime); // Creation time
           std::cout << "Modified      : " <<  std::ctime(&fileInfo.st_mtime); // Last mod time
           
           
          // if ( IsDirectory("c:\\temp")){ cout << "test";};
          return 1;
        }
        
        bool IsDirectory(char path[]) {
            int i = strlen(path) - 1;
            if (path[strlen(path)] == '.') {return true;} // exception for directories
            // such as \. and \..
            for(i; i >= 0; i--) {
                if (path[i] == '.') return false; // if we first encounter a . then it's a file
                else if (path[i] == '\\' || path[i] == '/') return true; // if we first encounter a \ it's a dir
            }
        }
        
        bool RemoveDirectory(string path) {
            if (path[path.length()-1] != '\\') path += "\\";
            // first off, we need to create a pointer to a directory
            DIR *pdir = NULL; // remember, it's good practice to initialise a pointer to NULL!
            pdir = opendir (path.c_str());
            struct dirent *pent = NULL;
            if (pdir == NULL) { // if pdir wasn't initialised correctly
                return false; // return false to say "we couldn't do it"
            } // end if
            char file[256];
        
            int counter = 1; // use this to skip the first TWO which cause an infinite loop (and eventually, stack overflow)
            while (pent = readdir (pdir)) { // while there is still something in the directory to list
                if (counter > 2) {
                    for (int i = 0; i < 256; i++) file[i] = '\0';
                    strcat(file, path.c_str());
                    if (pent == NULL) { // if pent has not been initialised correctly
                        return false; // we couldn't do it
                    } // otherwise, it was initialised correctly, so let's delete the file~
                    strcat(file, pent->d_name); // concatenate the strings to get the complete path
                    if (IsDirectory(file) == true) {
                        RemoveDirectory(file);
                    } else { // it's a file, we can use remove
                        remove(file);
                    }
                } counter++;
            }
        
            // finally, let's clean up
            closedir (pdir); // close the directory
            if (!rmdir(path.c_str())) return false; // delete the directory
            return true;
        }
};
